x = read.table('fpkm.tsv', header=T, stringsAsFactors=F, sep='\t', check.names=F)
colnames(x)[1] = 'GeneName'


gsea.cmd = 'geneSet="GSEADB"; prefix="PREFIX"; java -cp /Users/hdang/apps/gsea/gsea-3.0.jar -Xmx16000m xtools.gsea.Gsea -res expr.txt -cls class.cls#CONDITION_versus_CONTROL -gmx /Users/hdang/apps/gsea/dbs/v6.2/$geneSet -collapse false -mode Max_probe -norm meandiv -nperm 1000 -permute gene_set -rnd_type no_balance -scoring_scheme weighted -rpt_label my_analysis -metric Signal2Noise -sort real -order descending -include_only_symbols true -make_sets true -median false -num 100 -plot_top_x 100 -rnd_seed timestamp -save_rnd_lists false -set_max 500 -set_min 15 -zip_report false -out $prefix -gui false'

dbs = c('H'='h.all.v6.2.symbols.gmt', 'C2'='c2.all.v6.2.symbols.gmt', 'GO'='c5.all.v6.2.symbols.gmt', 'CP'='c2.cp.v6.2.symbols.gmt')
dbs = dbs[1]

conds = c('EGF', 'HYD', 'HYD-EGF')


for (con in conds){
    if (con == 'EGF'){cmp = 'EvC'}
    if (con == 'HYD'){cmp = 'HvC'}
    if (con == 'HYD-EGF'){cmp = 'HEvC'}
    y = x[, c('GeneName', grep(paste0("^", con, "-R\\d+$|CONTROL"), colnames(x), value=T))]
    dir.create(cmp)
    write.table(y, file=paste0(cmp, '/expr.txt'), row.names=F, quote=F, sep='\t')
    con = gsub('-', '', con)
    cls = paste0("4 2 1\n#CONTROL ", con, '\nCONTROL CONTROL ', con, ' ', con)
    write(cls, file=paste0(cmp, '/class.cls'))
    cmds = ''
    for (i in 1:length(dbs)){
        prefix = names(dbs)[i]
        db = dbs[i]
        cmd = gsea.cmd
        cmd = gsub('GSEADB', db, cmd)
        cmd = gsub('PREFIX', prefix, cmd)
        cmd = gsub('CONDITION', con, cmd)
        cmds = paste0(cmds, '\n', cmd)
    }

    write(paste0(cmds, '\n'), file=paste0(cmp, '/gsea.sh'))
}


